Imports System.Threading
Imports System.Net
Imports System.Net.Sockets

Public Class CMySckServer
    Public Const iServerPort As Integer = 9000
    Public Const strServerIP As String = "localhost"

    Dim sckAccept As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
    Dim ListenThread As Thread
    Dim ParentForm As Form1
    Dim bThread As Boolean
    Public cllSocket As New Collection()
    Public Shared qque As Queue = New Queue()

    Public Sub SetParentForm(ByRef pf As Object)
        ParentForm = pf
    End Sub

    Public Sub SetThreadStop()
        bThread = False
    End Sub

    Public Sub Create()
        Dim hostip As IPAddress = Dns.Resolve(strServerIP).AddressList(0)
        Dim ephost As New IPEndPoint(IPAddress.Any, iServerPort)
        sckAccept.Bind(ephost)
        sckAccept.Listen(5)

        ListenThread = New Thread(AddressOf DoListen)
        ListenThread.Start()
    End Sub

    Public Sub DoListen()
        bThread = True

        While bThread
            Dim sckClient As CMySckClient = New CMySckClient(sckAccept.Accept())
            sckClient.SetForm(ParentForm)

            If ParentForm.sGame.iCurUser < 3 Then
                ParentForm.sGame.iCurUser += 1
                sckClient.Send(CStr(ParentForm.sGame.iCurUser))
            End If

            cllSocket.Add(sckClient)
        End While
    End Sub

    Public Sub Send(ByVal strSend As String)
        Dim sck As CMySckClient
        For Each sck In cllSocket
            sck.Send(strSend)
        Next
    End Sub

    Public Sub Enqueue(ByVal strBuff As Object)
        qque.Enqueue(strBuff)
    End Sub

    Protected Overrides Sub Finalize()
        ListenThread.Abort()
    End Sub
End Class
